<?php

if(!defined('_PS_VERSION_')){
	exit;
}
include_once(_PS_MODULE_DIR_ .'/gpndata/library/gpndata.php');

class GpnDataPaymentModuleFrontController extends ModuleFrontController{


    public $ssl = true;
	public $display_column_left = false;

	/**
     * @see FrontController::initContent()
     */
	public function initContent()
	{
        $this->display_column_left = false;
		parent::initContent();
        $cart = $this->context->cart;
        if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active) {
            Tools::redirect('index.php?controller=order&step=1');
        }
        // Check that this payment option is still available in case the customer changed his address just before the end of the checkout process
        $authorized = false;
        foreach (Module::getPaymentModules() as $module) {
            if ($module['name'] == 'gpndata') {
                $authorized = true;
                break;
            }
        }

        if (!$authorized) {
            die($this->module->l('This payment method is not available.', 'validation'));
        }

        return $this->_iframe();
    }

    private function _iframe() {

        $products = $this->context->cart->getProducts();
        $product_list = '';
        foreach($products as $product){
            $product_list[] = $product['name'].' x '.$product['cart_quantity'];
        }


        $merchanttransid = $this->context->cart->id.'-'.time().rand(100,999);
        $description = (!empty(Configuration::get('GPNDATA_PAYMENT_IFRAME_DESCRIPTION')) ? Configuration::get('GPNDATA_PAYMENT_IFRAME_DESCRIPTION') . " " . $merchanttransid : "Order #" . implode(", ", $product_list));
        $key = sha1(sha1($merchanttransid).'::'.Configuration::get('GPNDATA_PRETTY_NAME'));

        $success_url = Tools::getHttpHost(true).__PS_BASE_URI__.'modules/gpndata/validation.php?&id_cart='.(int)$this->context->cart->id.'&transactionid='.$merchanttransid.'&key='.$key;
        $failure_url = Tools::getHttpHost(true).__PS_BASE_URI__.'modules/gpndata/validation.php?&id_cart='.(int)$this->context->cart->id.'&transactionid='.$merchanttransid.'&key='.$key;

        $address = new Address(intval($this->context->cart->id_address_invoice));
        $country_code  = GPNDataAPI::mapIso(CountryCore::getIsoById($address->id_country));
        $invoice_state = new State($address->id_state);
        $cart_curency = new Currency((int)$this->context->cart->id_currency);
        $state = $country_code == 'USA' ? $invoice_state->iso_code : '';
        $payment_data = array(
            'data-locale' => Configuration::get('GPN_DATA_IFRAME_LANGUAGE'),
            'data-merchant-id' => Configuration::get('GPNDATA_PRETTY_NAME'),
            'data-success-url' => $success_url,
            'data-failure-url' => $failure_url,
            'data-order-id' => $merchanttransid ,
            'data-amount' => strval($this->context->cart->getOrderTotal(true)),
            'data-currency' => $cart_curency->iso_code,
            'data-logo' => Configuration::get('GPNDATA_LOGO_URL'),
            'data-description' => $description,
            'data-company' => Configuration::get('GPNDATA_PAYMENT_MERCHANT_NAME'),
            'data-customer-firstname' => $this->context->customer->firstname,
            'data-customer-lastname' => $this->context->customer->lastname,
            'data-customer-email' => $this->context->customer->email,
            'data-customer-phone' => $address->phone,
            'data-customer-addressline' => $address->address1,
            'data-customer-zipcode' => $address->postcode,
            'data-customer-city' => $address->city,
            'data-customer-country' => $country_code,
            'data-customer-state' =>  $state,
            'data-merchant-spec1' => $merchanttransid,
            'iframe-url' => Configuration::get('GPNDATA_IFRAME_URL')
        );
        $this->context->smarty->assign([
                'payment_data' => $payment_data
            ]);
		$this->setTemplate('payment_execution.tpl');
    }
}
?>