<link rel="stylesheet" type="text/css" href="{$module_dir}css/gpn.css">

    <div class="table-responsive-row clearfix">

        <div class="panel col-lg-13" id="gpn-ord-div">
            <h2 id="gpn-ord-h2">Payment information</h2>
            <img id="gpn-ord-logo" src="{$module_dir}img/logo-s.png" alt="GPN DATA" />

            <table class="table table-striped table-bordered">
                <tr class="gpn-ord-tr">
                    <td>Transaction number</td>
                    <td class="gpn-txt-b">{$transaction['transaction']['merchant_trans_id']}</td>
                </tr>
                <tr class="gpn-ord-tr">
                    <td>Current transaction state</td>
                    <td class="gpn-txt-b">{$transaction['transaction']['gateway_transaction_state']}</td>
                </tr>
                <tr class="gpn-ord-tr">
                    <td>Current state description</td>
                    <td>{$transaction['transaction']['gateway_transaction_description']}</td>
                </tr>
                <tr class="gpn-ord-tr">
                    <td>Status date</td>
                    <td>{$transaction['transaction']['date_added']}</td>
                </tr>
                <tr class="gpn-ord-tr">
                    <td>Total amount</td>
                    <td class="gpn-txt-b">{$transaction['transaction']['payment_amount']}</td>
                </tr>
                <tr class="gpn-ord-tr">
                    <td>Currency</td>
                    <td class="gpn-txt-b">{$transaction['transaction']['curcode']}</td>
                </tr>
                <tr class="gpn-ord-tr">
                    <td>Installment count</td>
                    <td class="gpn-txt-b">{$transaction['transaction']['installment_count']}</td>
                </tr>
                {if $transaction['transaction']['is_chargeback']}
                <tr class="gpn-ord-tr">
                    <td style="background-color:lightblue; font-weight:bold;">Chargeback status</td>
                    <td class="gpn-txt-b" style="background-color:lightblue;font-weight:bold;">{$transaction['transaction']['is_chargeback']}</td>
                </tr>
                {/if}
                <tr>
                    <td>Transactions</td>
                    <td>
                        <table class="table table-striped table-bordered" id="gpndata_transactions">
                            <thead>
                                <tr class="gpn-ord-tr">
                                    <td>
                                        <strong>Status date</strong>
                                    </td>
                                    <td>
                                        <strong>Status</strong>
                                    </td>
                                    <td>
                                        <strong>Amount</strong>
                                    </td>
                                    <td>
                                        <strong>Description</strong>
                                    </td>
                                    <td>
                                        <strong>Additional text</strong>
                                    </td>
                                    <td>
                                        <strong>Error message</strong>
                                    </td>
                                </tr>
                            </thead>
                            <tbody>
                                {foreach from=$transaction['transaction_adjustments'] key=transaction_adjustment_id item=i}
                                <tr class="gpn-ord-tr">
                                    <td> {$i.date_added}</td>
                                    <td> {$i.status}</td>
                                    <td> {$i.amount}</td>
                                    <td> {$i.description}</td>
                                    <td> {$i.additional_text}</td>
                                    <td> {$i.errormessage}</td>
                                </tr>
                                {/foreach}
                            </tbody>
                        </table>
                    </td>
                </tr>
                {if $transaction['transaction']['is_voided'] == 0 && $transaction['transaction']['is_declined'] == 0 && $transaction['transaction']['is_chargeback'] == 0
                && $transaction['transaction']['hide_refund_button'] == 0}
                <!-- If payment is captured add refund option-->
                {if $transaction['transaction']['is_captured'] == 1}
                <tr>
                    <td>Refunded?</td>
                    <td id="capture_status">
                        {if $transaction['transaction']['is_refund_pending'] == 1}
                        <span class="capture_text">Refund pending approval from GPN Data</span>
                        {else}
                        <span class="capture_text">No</span>&nbsp;&nbsp;
                        <a class="button btn btn-primary" id="button_refund" data-toggle="modal" data-target="#transaction-modal" onclick="setTransactionAction('refund')">
                            Refund
                        </a> <span class="btn btn-primary" id="img_loading_capture" style="display:none;">
                            <i class="fa fa-circle-o-notch fa-spin fa-lg"></i>
                        </span>
                        {/if}
                    </td>
                </tr>
                {/if}

                {if $transaction['transaction']['is_refunded'] == 0 && $transaction['transaction']['is_voided'] == 0 && $transaction['transaction']['is_chargeback'] == 0}
                <tr>
                    <td>Captured?</td>
                    <td id="capture_status">

                        {if $transaction['transaction']['is_captured'] == 1}
                        <span class="capture_text">Yes</span>
                        {else}
                        <span class="capture_text">No</span>&nbsp;&nbsp;
                        <a class="button btn btn-primary" id="button_void" data-toggle="modal" data-target="#transaction-modal" onclick="setTransactionAction('capture')">
                            Capture
                        </a> <span class="btn btn-primary" id="img_loading_capture" style="display:none;">
                            <i class="fa fa-circle-o-notch fa-spin fa-lg"></i>
                        </span>
                        {/if}
                    </td>
                </tr>
                {/if}
                {/if}
                {if $transaction['transaction']['is_declined'] == 0}
                {if $transaction['transaction']['is_captured'] == 0 && $transaction['transaction']['is_refunded'] == 0}
                <tr>
                    <td>Voided?</td>
                    <td id="capture_status">
                        {if $transaction['transaction']['is_voided'] == 1}
                        <span class="capture_text">Yes</span>
                        {else}
                        <span class="capture_text">No</span>&nbsp;&nbsp;
                        <a class="button btn btn-primary" id="button_void" data-toggle="modal" data-target="#transaction-modal" onclick="setTransactionAction('void')">
                            Void
                        </a> <span class="btn btn-primary" id="img_loading_capture" style="display:none;">
                            <i class="fa fa-circle-o-notch fa-spin fa-lg"></i>
                        </span>
                        {/if}
                    </td>
                </tr>
                {/if}
                {/if}
            </table>

            <!-- Modal -->
            <div id="transaction-modal" class="modal fade" role="dialog">
                <div class="modal-dialog">
                    <!-- Modal content-->
                    <div class="modal-content">
                        <div class="modal-header">
                            <button type="button" class="close" data-dismiss="modal">&times;</button>
                            <h2 class="modal-title" id = "modal-title-text">
                                Capture transaction
                            </h2>
                        </div>
                        <div class="modal-body">
                            <form id="transaction_form" role="form" action="{$gpndata_form|escape:'htmlall':'UTF-8'}" method="post">
                                <input type="hidden" name = "transaction-action" id="transaction-action" value=""/>
                                <input type="hidden" name = "order_id" id="order_id" value="{$order_id|escape:'htmlall':'UTF-8'}"/>
                                <h4 id="transaction-type-action-text"></h4>
                                <div class="form-group" id="refund-div-reason" hidden="">
                                    <label for="refund_reason">Reason:</label>
                                    <input type="text" class="form-control" id="refund-reason" name="refund-reason" placeholder="Please enter valid refund reason!" value=""/>
                                </div>
                                <div class="form-group" id="amount-group">
                                    <label for="refund_amount">Amount:</label>
                                    <input type="text" class="form-control" id="transaction-amount" name="transaction-amount" placeholder="Amount available: {$transaction['transaction']['payment_amount']}"/>
                                </div>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <label id="lbl-action" style="display:none;font-size:larger;float:left;">Please wait, operation action in progress..</label>
                            <button type="button" class="btn btn-default" name="transaction-button-submit" id="transaction-button-submit">Submit request</button>
                            <button type="button" class="btn btn-default" data-dismiss="modal" id="cancel">Close</button>
                        </div>
                    </div>

                </div>
            </div>
        </div>
    </div>
<script data-cfasync="false" type="text/javascript">
    document.getElementById('transaction-button-submit').addEventListener("click", function(evt) {
        var action = document.getElementById('transaction-action').value;
        if(validateInput(action) || action == 'void'){
          $('#transaction-button-submit').attr('disabled', '');
          $('#cancel').attr('disabled', '');
          $('#lbl-action').css('display', '');
          $.post("{$link->getModuleLink('gpndata', 'gatewayoperations', array(), Configuration::get('PS_SSL_ENABLED'))}", { 
                ajax : true, 
                id_order: $('#order_id').val(), 
                transaction_action : action, 
                refund_reason: $('#refund-reason').val(),
                transaction_amount: $('#transaction-amount').val()
            }, 
                function(returnedData){
                    if(returnedData.status == 'success'){
                        location.reload();
                    }
                    else{
                        alert(returnedData.message);
                        $('#transaction-button-submit').removeAttr('disabled');
                        $('#cancel').removeAttr('disabled');
                        $('#lbl-action').css('display', 'none');
                    }
                });
        }
    }, true);

    function setTransactionAction(action){
        document.getElementById('transaction-action').value = action;
        var modal_title_text = document.getElementById('modal-title-text');
        var text = document.getElementById('transaction-type-action-text');
        if(action == 'capture'){
            text.textContent = 'Please enter capture amount';
            document.getElementById('amount-group').removeAttribute('hidden');
        }
        if(action == 'refund'){
            document.getElementById('refund-div-reason').removeAttribute('hidden');
            document.getElementById('amount-group').removeAttribute('hidden');
            modal_title_text.textContent = 'Refund transaction';
            text.textContent = 'Please enter the refund reason and amount.';
            document.getElementById('refund-reason').value = '';
        }
        if(action == 'void'){
            modal_title_text.textContent = 'Void transaction';
            text.textContent = 'This process is not reversible.';
            document.getElementById('amount-group').setAttribute('hidden', '');
        }
        document.getElementById('transaction-amount').value = '';
        $('#lbl-action').css('display', 'none');
    }

    function validateInput(action){
        
        var refund_reason = document.getElementById('refund-reason');
        var amount = document.getElementById('transaction-amount');
         switch (action){
                case 'capture':
                    if(!isNumeric(amount.value)){
                        alert("Capture amount must be numeric value!");
                        amount.focus();
                        return false;
                    }
                    return true;
                    break;
                case 'void':
                    break;
                case 'refund':
                      if(refund_reason.value.length == 0){
                        alert("Refund reason must be a entered!");
                        refund_reason.focus();
                        return false;
                      }
                      if(!isNumeric(amount.value)){
                        alert("Refund amount must be numeric value!");
                        amount.focus();
                        return false;
                      }
                    return true;
                    break;
                default:
                    break;
            }
        return false;
    }
    
    function isNumeric(n) {
        return !isNaN(parseFloat(n)) && isFinite(n);
    }
</script>
